; **************************************************************************
; Catgorie : TEMPLATE KEYGEN 1 pour Forum Keygenning FFF.
; Type      : NOM/SERIAL
; Asm       : MASM 7 
; Auteur    : PRESAGE / FFF
; Cible     : jB Crypto-KeygenMe 1
; **************************************************************************

.486p
.model flat, stdcall
option casemap :none

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                             IMPORTS, DEF
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
include		\masm32\include\windows.inc
include		\masm32\include\user32.inc
include		\masm32\include\kernel32.inc
include		\masm32\include\comctl32.inc
include		\masm32\include\comdlg32.inc

includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\comctl32.lib
includelib	\masm32\lib\comdlg32.lib

DlgKgProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                              CONSTANTS
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const 

IDD_DIALOGBOX		equ	101
IDI_ICON		equ	102
IDB_BITMAP		equ	103
IDC_INFO		equ	1001
IDC_EXIT		equ	1002
IDC_NOMBOX		equ	1003
IDC_SERIALBOX		equ	1004
IDC_RIPEBOX		equ	1005
IDC_STATIC		equ	-1

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                                 DATA
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data

NomLong		db "Nom trop long (moins de 31 lettres)",0
NomCourt	db "Plus de 2 lettres pour le nom !",0
RSAErr		db "RSA s'est plant.",0
BeginNom	db "Lisegrim [FFF]",0
InfoCaption	db "Info...",0
InfoMsg		db "Protection :",13,10
		db "RipeMD128 + RSA 160",13,10,13,10
		db "DLL RSA de Ghiribizzo",13,10
		db "DLL RipeMD de ????",13,10,13,10
		db "Un grand merci  jB pour cet exercice intressant :)",13,10
		db "Un grand bonjour  tous les courageux du forum Keygen",13,10
		db "de FFF.",13,10,13,10
		db "Greetings  Analyst et Christal ( qui j'ai honteusement",13,10
		db "prlev les DLL de son Cryptotool... Mais la vengeance du",13,10
		db "WiA n'est que peu mchante face  l'AFFRONT dans Cryptotool !) :P",0
; ---------
DLLname1	db "ripemd.dll",0
p1name		db "RIPEMD128",0
DLLname2	db "ghirirsa.dll",0
p2name		db "ghRSAexp",0
lpRipe		dd 0
lpRSA		dd 0
; ---------
BASERSA		dd 16
RSA_n		db "86ADBCFBC23A91653F048B24A64A20BE0418E279",0
		db 4 dup (0)
RSA_d		db "37D67D6CAA868623693056BC2412AFF40C741451",0
		db 4 dup (0)
cctab		db "0123456789ABCDEF"
BUF_NOM		db 100 dup (0)
SERIAL		db 100 dup (0)
TMP_BUF1	db 100 dup (0)
RIPE		db 100 dup (0)

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                                 DATA?
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
 
hInstance	dd ?
NB_NOM		dd ?
hDLL1		dd ?
hDLL2		dd ?

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                                 CODE
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code 

start:
	invoke	LoadLibrary, offset DLLname1
	mov	hDLL1, eax
	invoke	GetProcAddress, hDLL1, offset p1name
	mov	lpRipe, eax
	invoke	LoadLibrary, offset DLLname2
	mov	hDLL2, eax
	invoke	GetProcAddress, hDLL2, offset p2name
	mov	lpRSA, eax
	invoke	GetModuleHandle, NULL
	mov	hInstance, eax
	invoke	DialogBoxParam, hInstance, IDD_DIALOGBOX, NULL, offset DlgKgProc, 0         
	invoke	FreeLibrary,hDLL1
	invoke	FreeLibrary,hDLL2
	invoke	ExitProcess, NULL

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                             MAIN DIALOG
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DlgKgProc	PROC	hWnd	:DWORD,
			uMsg	:DWORD,
			wParam	:DWORD,
			lParam	:DWORD

	mov	eax,uMsg    

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.if eax == WM_CLOSE
		invoke	EndDialog, hWnd, NULL

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_LBUTTONDOWN
		mov	eax, lParam
		invoke	PostMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, eax

	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_INITDIALOG
		xor	eax, eax
		invoke	LoadIcon,hInstance,IDI_ICON
		invoke	SendMessage,hWnd,WM_SETICON,ICON_SMALL,EAX
		invoke	SetDlgItemText, hWnd, IDC_NOMBOX, offset BeginNom
	; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	.elseif eax == WM_COMMAND
		mov	eax,wParam
		mov	edx,wParam
		shr	edx,16
		; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		.if ax == IDC_NOMBOX
			push	32h
			push	offset BUF_NOM
			push	IDC_NOMBOX
			push	hWnd
			call	GetDlgItemTextA
			mov	dword ptr [NB_NOM], eax

			cmp	eax, 2
			jb	Nom_court

			cmp	eax, 30	
			jg	Nom_long
			
			; On Hashe le Nom en Ripe-MD128 via la DLL
			push	offset BUF_NOM
			push	eax
			push	offset TMP_BUF1
			call	lpRipe

			; conversion ASCII et affichage
			mov     ecx, 10h
			mov     esi, offset TMP_BUF1
			mov     edi, offset RIPE
			call    sub_4027E9

			invoke	SetDlgItemText, hWnd, IDC_RIPEBOX, offset RIPE

			; dcryptage RSA 160 via la DLL
			push	offset SERIAL
			push	offset RIPE
			push	BASERSA
			push	offset RSA_n
			push	offset RSA_d
			call	lpRSA

			invoke	SetDlgItemText, hWnd, IDC_SERIALBOX, offset SERIAL
			jmp	Fin_Generer

			;----------- NOM TROP COURT --------------
			Nom_court:
			invoke	SetDlgItemText, hWnd, IDC_SERIALBOX, offset NomCourt
			invoke	SetDlgItemText, hWnd, IDC_RIPEBOX, offset NomCourt
			jmp	Fin_Generer		

			;----------- NOM TROP LONG -----------------
			Nom_long:
			invoke	SetDlgItemText, hWnd, IDC_SERIALBOX, offset NomLong
			invoke	SetDlgItemText, hWnd, IDC_RIPEBOX, offset NomLong

			Fin_Generer:
			invoke	RtlZeroMemory, offset BUF_NOM, 100	; on remet  vide les buffers
			invoke	RtlZeroMemory, offset SERIAL, 100
			invoke	RtlZeroMemory, offset TMP_BUF1, 100
			invoke	RtlZeroMemory, offset RIPE, 100

		; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		.elseif ax == IDC_INFO
			invoke MessageBox, hWnd, offset InfoMsg , offset InfoCaption, MB_OK 
		; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		.elseif ax == IDC_EXIT
			invoke	EndDialog, hWnd, eax
		.endif
	.else
		mov	eax, FALSE
		ret
	.endif

	mov	eax,TRUE
	ret

DlgKgProc	ENDP

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	RIP DU CONVERTISSEUR ASCII
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub_4027E9	proc near		; CODE XREF: DialogFunc+CCp
					; DialogFunc+129p

var_8		= dword	ptr -8
var_4		= dword	ptr -4

		enter	8, 0
		mov	[ebp+var_4], ecx
		xor	ecx, ecx
		xor	eax, eax
		mov	[ebp+var_8], eax

loc_4027F7:				; CODE XREF: sub_4027E9+3Ej
		mov	al, [esi+ecx]
		mov	ebx, eax
		shr	eax, 4
		add	al, 90h
		daa
		adc	al, 40h
		daa
		mov	edx, [ebp+var_8]
		add	edx, ecx
		mov	[edi+edx], al
		inc	[ebp+var_8]
		mov	al, bl
		and	eax, 0Fh
		add	al, 90h
		daa
		adc	al, 40h
		daa
		mov	edx, [ebp+var_8]
		add	edx, ecx
		mov	[edi+edx], al
		inc	ecx
		cmp	ecx, [ebp+var_4]
		jnz	short loc_4027F7
		leave
		retn
sub_4027E9	endp
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
END	start
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
